﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RDFMatViewCalculation.Logging
{
    public class Logger
    {
        private static string _fullFileName;
        private static string FullFileName
        {
            get
            {
                if (!string.IsNullOrEmpty(_fullFileName))
                    return _fullFileName;
                try
                {
                    if (!System.IO.Directory.Exists(dir))
                        System.IO.Directory.CreateDirectory(dir);

                    _fullFileName = dir + System.IO.Path.DirectorySeparatorChar + "RDFMatViewCalculatorLogger_{0}.log";
                    System.IO.StreamWriter sw = new System.IO.StreamWriter(string.Format(_fullFileName, DateTime.Now.ToString("yyyyMMdd")), true);
                    sw.WriteLine("==========================\r\n" + DateTime.Now.ToString() + " New entries.");
                    sw.Flush();
                    sw.Close();
                }
                catch (Exception)
                {
                    // TBD Ignore Error
                }
                return _fullFileName;
            }
        }
        private static string dir = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location), "Logs");

        public static void log(string text)
        {
            try
            {
                System.IO.StreamWriter sw = new System.IO.StreamWriter(string.Format(FullFileName, DateTime.Now.ToString("yyyyMMdd")), true);
                //successes.AppendLine(DateTime.Now.ToString() + ": " + text);
                sw.WriteLine(DateTime.Now.ToString() + ": " + text);
                sw.Flush();
                sw.Close();
            }
            catch (Exception)
            {
                // TBD Ignore Error
            }
        }


        private static string _separateFullFileName;
        private static string SeparateFullFileName
        {
            get
            {
                if (!string.IsNullOrEmpty(_separateFullFileName))
                    return _separateFullFileName;
                try
                {
                    if (!System.IO.Directory.Exists(dir))
                        System.IO.Directory.CreateDirectory(dir);

                    _separateFullFileName = dir + System.IO.Path.DirectorySeparatorChar + "RDFMatViewCalculatorLogger_Separate_{0}.log";
                    System.IO.StreamWriter sw = new System.IO.StreamWriter(string.Format(_separateFullFileName, DateTime.Now.ToString("yyyyMMdd")), true);
                    sw.WriteLine("==========================\r\n" + DateTime.Now.ToString() + " New entries.");
                    sw.Flush();
                    sw.Close();
                }
                catch (Exception)
                {
                    // TBD Ignore Error
                }
                return _separateFullFileName;
            }
        }

        public static void logSeparately(string text)
        {
            try
            {
                System.IO.StreamWriter sw = new System.IO.StreamWriter(string.Format(SeparateFullFileName, DateTime.Now.ToString("yyyyMMdd")), true);
                //successes.AppendLine(DateTime.Now.ToString() + ": " + text);
                sw.WriteLine(DateTime.Now.ToString() + ": " + text);
                sw.Flush();
                sw.Close();
            }
            catch (Exception)
            {
                // TBD Ignore Error
            }
        }
    }
}
