﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RDFMatViewCalculation.Logic
{
    [Serializable]
    public class View
    {
        public CuboidNode Node { get; set; }
        public int Size { get; set; }
        public int Cost { get; set; } //// how many tuples need to be processed to get this view
        public int FactBaseSize { get; set; } //// how many observations exist for this view
        public double Completeness { get; set; } //// how many tuples need to be processed to get this view
        public List<ViewPath> Paths { get; set; }
        public ViewPath SelectedPath { get; set; }

        public List<ViewPath> GetCompletePaths() {
            List<ViewPath> paths = new List<ViewPath>();
            foreach (ViewPath item in Paths)
            {
                if (item.Dimensions.SelectMany(c => c.Steps).Where(d => d.IsPartial == true).FirstOrDefault() == null)
                    paths.Add(item);
            }
            return paths;
        }

        public override string ToString()
        {
            return "Nodes: " + Node.ToString() + ", size: " + Size; // base.ToString();
        }
    }
}
