﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RDFMatViewCalculation.Logic
{
    [Serializable]
    public class ViewPath
    {
        public List<HierarchyPath> Dimensions { get; set; }
        public int Cost { get; set; }
        public double Completeness { get; set; }
        public bool IsPartial
        {
            get
            {
                //// if steps contain IsPartial == true then it is partial
                return (Dimensions.SelectMany(c => c.Steps).Where(d => d.IsPartial == true).FirstOrDefault() != null);
            }
        }
    }
}
